'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var style = {
  card: {
    fontFamily: 'Roboto, sans-serif',
    flexGrow: 1,
    height: 215,
    margin: '8px 0',
    position: 'relative',
    boxShadow: '0 3px 6px rgba(0, 0, 0, 0.16), 0 3px 6px rgba(0, 0, 0, 0.23)'
  },
  cardHover: {
    boxShadow: '0 14px 28px rgba(0, 0, 0, 0.25), 0 10px 10px rgba(0, 0, 0, 0.22)'
  },
  container: {
    padding: 12,
    float: 'left'
  },
  containerWithImage: {
    position: 'absolute',
    left: 184
  },
  headerButton: {
    position: 'absolute',
    right: 8,
    top: 8,
    cursor: 'pointer'
  },
  image: {
    height: 164,
    width: 184,
    float: 'left',
    backgroundSize: 'cover'
  },
  header: {
    padding: '0 0 8px'
  },
  headerTitle: {
    color: '#263238',
    margin: 0,
    textTransform: 'uppercase',
    fontSize: '1rem'
  },
  headerSubtitle: {
    color: '#90A4AE',
    margin: 0,
    fontSize: '.85rem'
  },
  contentTitle: {
    margin: 0
  },
  contentText: {
    color: '#607D8B',
    margin: '4px 0 0',
    fontSize: '.9rem'
  },
  contentPrimary: {
    padding: '8px 0 0',
    color: '#263238',
    fontSize: '.9rem'
  },
  contentSecondary: {
    padding: '6px 16px 0 0',
    color: '#263238',
    fontSize: '.9rem'
  },
  footer: {
    position: 'absolute',
    backgroundColor: '#E3E2E2',
    width: '100%',
    height: 51,
    top: 'auto',
    right: 0,
    bottom: 0,
    left: 0
  },
  footerHover: {
    cursor: 'pointer',
    backgroundColor: '#DBDBDB'
  },
  footerStatus: {
    lineHeight: '12px',
    float: 'left'
  },
  footerStatusIcon: {
    lineHeight: '12px',
    padding: '14px 0 14px 12px',
    float: 'left'
  },
  footerStatusName: {
    lineHeight: '51px',
    float: 'left',
    paddingLeft: 12
  },
  footerButton: {
    float: 'right',
    lineHeight: '51px',
    borderLeft: '1px solid #CCCBCB',
    padding: '0 12px',
    textTransform: 'uppercase',
    fontSize: '.9rem'
  }
};

var CompatCard = function (_Component) {
  _inherits(CompatCard, _Component);

  function CompatCard(props) {
    _classCallCheck(this, CompatCard);

    var _this = _possibleConstructorReturn(this, (CompatCard.__proto__ || Object.getPrototypeOf(CompatCard)).call(this, props));

    _this.handleToggleFooterHover = function () {
      var footerHovered = _this.state.footerHovered;

      _this.setState({ footerHovered: !footerHovered });
    };

    _this.handleToggleCardHover = function () {
      var cardHovered = _this.state.cardHovered;

      _this.setState({ cardHovered: !cardHovered });
    };

    _this.handleSelect = function () {
      var onSelect = _this.props.onSelect;

      onSelect && onSelect(_this.props.id);
    };

    _this.handleFooterClick = function () {
      var onFooterButtonClick = _this.props.onFooterButtonClick;

      onFooterButtonClick && onFooterButtonClick(_this.props.id);
    };

    _this.handleHeaderClick = function () {
      var onHeaderButtonClick = _this.props.onHeaderButtonClick;

      onHeaderButtonClick && onHeaderButtonClick(_this.props.id);
    };

    _this.renderHeader = function () {
      var _this$props = _this.props,
          title = _this$props.title,
          subtitle = _this$props.subtitle;

      return _react2.default.createElement(
        'header',
        { style: style.header },
        _react2.default.createElement(
          'h3',
          { style: style.headerTitle },
          title
        ),
        _react2.default.createElement(
          'p',
          { style: style.headerSubtitle },
          subtitle
        )
      );
    };

    _this.renderContent = function () {
      var _this$props2 = _this.props,
          contentTitle = _this$props2.contentTitle,
          contentText = _this$props2.contentText,
          primaryText = _this$props2.primaryText,
          secondaryText = _this$props2.secondaryText;


      return _react2.default.createElement(
        'main',
        { className: 'content' },
        _react2.default.createElement(
          'p',
          { style: style.contentTitle },
          contentTitle
        ),
        _react2.default.createElement(
          'p',
          { style: style.contentText },
          contentText
        ),
        _react2.default.createElement(
          'div',
          { style: style.contentPrimary },
          primaryText
        ),
        _react2.default.createElement(
          'div',
          { style: style.contentSecondary },
          secondaryText
        )
      );
    };

    _this.renderFooterIconAndText = function () {
      var _this$props3 = _this.props,
          footerIcon = _this$props3.footerIcon,
          footerStatus = _this$props3.footerStatus;
      var status = footerStatus.status,
          text = footerStatus.text;

      var _this$colorForStatus$ = _this.colorForStatus.get(status),
          color = _this$colorForStatus$.color;

      return _react2.default.createElement(
        'div',
        {
          style: _extends({}, style.footerStatus, { color: color })
        },
        !!footerIcon && _react2.default.createElement(
          'span',
          { style: style.footerStatusIcon },
          footerIcon
        ),
        _react2.default.createElement(
          'strong',
          { style: style.footerStatusName },
          text
        )
      );
    };

    _this.renderFooter = function () {
      var _this$props4 = _this.props,
          onFooterButtonClick = _this$props4.onFooterButtonClick,
          footerButtonLabel = _this$props4.footerButtonLabel;

      var hasButton = !!onFooterButtonClick;

      var footerSyle = _this.state.footerHovered ? _extends({}, style.footer, style.footerHover) : style.footer;

      return _react2.default.createElement(
        'footer',
        {
          className: 'card__footer',
          style: footerSyle,
          onMouseEnter: _this.handleToggleFooterHover,
          onMouseLeave: _this.handleToggleFooterHover,
          onClick: _this.handleFooterClick
        },
        !!_this.props.footerStatus && _this.renderFooterIconAndText(),
        hasButton && _react2.default.createElement(
          'div',
          { style: style.footerButton },
          footerButtonLabel
        )
      );
    };

    _this.state = {
      cardHovered: false,
      footerHovered: false
    };
    _this.colorForStatus = new Map([['awaiting', { color: '#BF360C' }], ['checking', { color: '#FF6F00' }], ['finished', { color: '#43A047' }], ['running', { color: '#1976D2' }]]);
    return _this;
  }

  _createClass(CompatCard, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          image = _props.image,
          onSelect = _props.onSelect,
          headerButton = _props.headerButton;

      var hasImage = !!image;
      var canSelect = !!onSelect;
      var hasHeaderButton = !!headerButton;

      var boxShadow = this.state.cardHovered ? style.cardHover.boxShadow : style.card.boxShadow;

      var cursor = canSelect ? 'pointer' : 'default';

      var containerWithImage = hasImage ? style.containerWithImage : {};

      var containerStyle = _extends({}, style.container, containerWithImage, {
        cursor: cursor
      });

      return _react2.default.createElement(
        'div',
        {
          style: _extends({}, style.card, { boxShadow: boxShadow }),
          onMouseEnter: this.handleToggleCardHover,
          onMouseLeave: this.handleToggleCardHover
        },
        hasImage && _react2.default.createElement('div', {
          style: _extends({}, style.image, { backgroundImage: 'url(' + this.props.image + ')' })
        }),
        hasHeaderButton && _react2.default.createElement(
          'div',
          {
            className: 'card__header_button',
            style: style.headerButton,
            onClick: this.handleHeaderClick
          },
          headerButton
        ),
        _react2.default.createElement(
          'div',
          {
            className: 'card__container',
            style: containerStyle,
            onClick: this.handleSelect
          },
          this.renderHeader(),
          this.renderContent()
        ),
        this.renderFooter()
      );
    }
  }]);

  return CompatCard;
}(_react.Component);

CompatCard.propTypes = {
  id: _propTypes2.default.number.isRequired,
  title: _propTypes2.default.string.isRequired,
  image: _propTypes2.default.string,
  subtitle: _propTypes2.default.string,
  contentTitle: _propTypes2.default.string,
  contentText: _propTypes2.default.string,
  primaryText: _propTypes2.default.string,
  secondaryText: _propTypes2.default.string,
  headerButton: _propTypes2.default.node,
  footerButtonLabel: _propTypes2.default.string,
  footerIcon: _propTypes2.default.node,
  footerStatus: _propTypes2.default.shape({
    status: _propTypes2.default.string,
    text: _propTypes2.default.string
  }),
  onSelect: _propTypes2.default.func,
  onFooterButtonClick: _propTypes2.default.func,
  onHeaderButtonClick: _propTypes2.default.func
};

exports.default = CompatCard;