'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _enzyme = require('enzyme');

var _CompatCard = require('./CompatCard');

var _CompatCard2 = _interopRequireDefault(_CompatCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Testing CompatCard', function () {

  var compartCardProps = {
    id: 1,
    title: 'title',
    image: 'image',
    subtitle: 'subtitle',
    contentTitle: 'contentTitle',
    contentText: 'contentText',
    primaryText: 'primaryText',
    secondaryText: 'secondaryText'
  };

  it('should render with props', function () {
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_CompatCard2.default, compartCardProps));

    expect('id' in wrapper.props()).toBe(true);
    expect('title' in wrapper.props()).toBe(true);
    expect('image' in wrapper.props()).toBe(true);
    expect('subtitle' in wrapper.props()).toBe(true);
    expect('contentTitle' in wrapper.props()).toBe(true);
    expect('contentText' in wrapper.props()).toBe(true);
    expect('primaryText' in wrapper.props()).toBe(true);
    expect('secondaryText' in wrapper.props()).toBe(true);
  });

  it('should select card', function () {
    var onSelect = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_CompatCard2.default, _extends({}, compartCardProps, {
      onSelect: onSelect
    })));

    wrapper.find('.card__container').simulate('click');
    expect(onSelect.calledOnce).toBe(true);
  });

  it('should select footer button', function () {
    var onFooterclick = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_CompatCard2.default, _extends({}, compartCardProps, {
      footerButtonLabel: 'open',
      onFooterButtonClick: onFooterclick
    })));

    wrapper.find('.card__footer').simulate('click');
    expect(onFooterclick.calledOnce).toBe(true);
  });

  it('should select header button', function () {
    var onHeaderclick = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_CompatCard2.default, _extends({}, compartCardProps, {
      headerButton: _react2.default.createElement(
        'button',
        { type: 'button' },
        'add'
      ),
      onHeaderButtonClick: onHeaderclick
    })));

    wrapper.find('.card__header_button').simulate('click');
    expect(onHeaderclick.calledOnce).toBe(true);
  });
});